from flask import Flask, request,render_template,jsonify,flash,redirect,url_for,get_flashed_messages
from functions import *
import config
from syntax_processor import *
import concurrent.futures
from trades import *
from trades_flat import *
from handler import*
import datetime
import importlib
from concurrent.futures import ThreadPoolExecutor, as_completed
import os
import pytz
from limit_entry import *



app = Flask(__name__)
app.config['SECRET_KEY'] = '123fdsgcsfgxgfg1514cgcd45'


@app.route('/login', methods=['GET', 'POST'])
def login():
    error = ''

    if 'X-Forwarded-For' in request.headers:
        proxy_data = request.headers['X-Forwarded-For']
        ip_list = proxy_data.split(',')
        user_ip = ip_list[0]  # first address in list is User IP
    else:
        user_ip = request.remote_addr  

    if request.method == 'POST':
        if request.form.get('username') != config.admin_username or \
                request.form.get('password') != config.admin_password:
            error = 'Invalid Credentials. Please try again.'
            flash(format('Invalid credentials. Please try again.'), 'error')
        else:
            #auth_data = request.form.to_dict(flat=True)
            write('auth.txt', 'authenticated')
            write('ip_address.txt', ip_address())
            return redirect(url_for('index'))
    return render_template('login.html', error=error)

@app.route('/logout', methods=['POST', 'GET'])
def logout():
    write('auth.txt', 'unauthenticated')
    write('ip_address.txt', '')
    return redirect(url_for('login'))

@app.route('/', methods=['GET'])
def main():
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    else:
        return redirect(url_for('index'))

@app.route('/password_reset',methods=['POST'])
def reset_password():
    if request.method == 'POST':
        admin_username = request.form.get('current_username')
        old_pass = request.form.get('current_password')
        new_pass = request.form.get('new_password')
        if admin_username == config.admin_username:
            if old_pass == config.admin_password:
                config.admin_password = new_pass
                with open('config.py', 'r') as f:
                    config_contents = f.read()
                new_config_contents = config_contents.replace(
                    f"admin_password = '{old_pass}'", f"admin_password = '{new_pass}'")
                with open('config.py', 'w') as f:
                    f.write(new_config_contents)
                    flash(format('Admin Password Changed Successfuly'), 'success')
                    
            else:
                flash(format('Current Admin Password Is Not Valid'), 'error')
        else:
            flash(format('Admin Username Is Not Valid'), 'error')
    return redirect(url_for('change_password'))

@app.route('/change_password', methods=['GET', 'POST'])
def change_password():        
    pass
    return render_template('change_password.html')

@app.route('/dashboard', methods=['GET', 'POST'])
def index():
    athens_tz = pytz.timezone('Europe/Athens')
    current_time = datetime.datetime.now(athens_tz)
    formatted_time = current_time.strftime('%Y-%m-%d %H:%M:%S.%f')
    # print(formatted_time)
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    # user = get_exchange('U7QGYV5RoTyfgvqbw8Zutn3EgQ15W9n55EDEtdGa5hGLeVSvDu2mlpHXu2Yol9B4', '1iY9f0Z9GYib9r4UrtLni5BDUNilTV9vFxr2cUTdozYfMOlcYGLwYGShDn4Zi6WM')
    # readable_time,side,symbol,price,margin_asset,commission,commission_asset,rPnl,nPnL,status,l_emoji,qty = last_trade_info(user,'ETHUSDT')
    
    # output.append(readable_time)
    # send_alert("5526457892:AAH6EyPCERxNRZIH0_So39LUSoNgU3akcY4","-1001798213741",message)
    # output.append(message)
    # try:    
    #     user.fapiPrivatePostMarginType ({'symbol': 'BTCUSDT','marginType': 'CROSSED',})
    #     output.append(f'Margin Type CROSSED is Set Successfuly for BTCUSDT')
    # except:
    #     output.append(f'Margin Type CROSSED is Already Set for BTCUSDT')
    # try:
    #     output.append(user.setLeverage(symbol = 'BTCUSDT',leverage = 20))
    #     output.append(f'Leverage 20 is Set Successfuly for BTCUSDT')
    # except Exception as e:
    #     output.append(e)
    #     output.append(f'Leverage 20 is NOT Set for BTCUSDT')
    if request.method == 'POST':
        quantity_syntax = request.form.get('qty',"")
        # leverage_syntax = request.form.get('leverage',"")
        # api_key_syntax = request.form.get('api_key',"")
        # api_secret_syntax = request.form.get('api_secret',"")
        # margin_type_syntax = request.form.get('margin_type',"")
        syntax = '{</br>"action": "{{strategy.order.action}}",</br>"market_position": "{{strategy.market_position}}",</br>"symbol": "{{ticker}}",</br>"price": "{{close}}",</br>"qty": '+'"' + \
                    quantity_syntax+'"''</br>}'
        return render_template('index.html',syntax=syntax)
    else:
        return render_template('index.html')


@app.route('/telegram_settings', methods=['GET', 'POST'])
def telegram_settings():
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    importlib.reload(config)
    if len(config.tg_token) > 0 and len(config.tg_token) > 0:
        tg_token = config.tg_token[:10]+'************'
        tg_channel = config.tg_channel[:10]+'************'
        return render_template('telegram_settings.html',tg_token=tg_token,tg_channel=tg_channel)
    else:
        tg_token = 'NO_TOKEN_FOUND'
        tg_channel = 'NO_CHANNEL_ID_FOUND'
        return render_template('telegram_settings.html',tg_token=tg_token,tg_channel=tg_channel)

@app.route('/set_token', methods=['GET', 'POST'])
def set_token():
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    output = []
    importlib.reload(config)
    output.append('#################  SAVING TG TOKEN ####################')
    if request.method == 'POST':
        tg_token = request.form.get('tg_token')
        tg_channel = request.form.get('tg_channel')
        if len(tg_token) > 0 and len(tg_channel) > 0:
            update_config('tg_token = ',tg_token,'tg_channel = ',tg_channel)
        else:
            output.append('NO TG TOKEN SUBMITTED')
    output.append('#################  End Of Request SET TG TOKEN ####################')

    write_output(output)

    return redirect(url_for('telegram_settings'))

@app.route('/history', methods=['GET', 'POST'])
def signals():
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    try:
        importlib.reload(config)
        Fetch_Trades_Symbol = read("spot_trade_history.txt")
        trade_symbol = request.form.get('trade-symbol',Fetch_Trades_Symbol).upper()
        trade_symbol = get_symbol_name(trade_symbol)
        Fetch_Trades_Symbol = write("spot_trade_history.txt",trade_symbol)
        Fetch_Trades_Symbol = read("spot_trade_history.txt")
        ftrades = json.dumps(user.fetch_closed_orders (trade_symbol ))
        ftrades = json.loads(ftrades)
        # aa = user.fetch_orders('XVGUSDT')
        # for a in aa:
        #     print(a)
        # contract_size = user.market(trade_symbol)
        # contract_size = contract_size['contractSize']
        # output.append(contract_size)
        df = pd.DataFrame(ftrades,columns=['timestamp','symbol','side','amount','average','status','cost'])
        df.rename(columns = {'timestamp':'TIME','symbol':'SYMBOL', 'side':'SIDE', 'amount':'QTY','average':'PRICE','status':'STATUS','cost':'COST (USDT)'}, inplace = True)
        df['TIME'] = pd.to_datetime(df['TIME'],unit='ms')
        france_tz = pytz.timezone('Europe/Paris')
        df['TIME'] = df['TIME'].dt.tz_localize('UTC').dt.tz_convert(france_tz)
        df = df.sort_values(by="TIME",ascending=False)

        return render_template('history.html',
                                tables=[df.to_html(classes='data')],
                                titles=df.columns.values)
    except Exception as e:
        print(e)
        flash(format(e), 'error')
        return render_template('history.html')

@app.route('/exchange_settings', methods=['GET', 'POST'])
def exchange_settings():
    auth_session = read('auth.txt')
    ip_session = str(read('ip_address.txt'))
    ip_add = ip_address()
    if auth_session != 'authenticated' or ip_session != ip_add:
        return redirect(url_for('login'))
    try:
        importlib.reload(config)
        if len(config.binance_api_key) > 0 and len(config.binance_api_secret) > 0:
            binance_api_key = config.binance_api_key[:10]+'************'
            binance_api_secret = config.binance_api_secret[:10]+'************'
        else:
            binance_api_key = 'NO_API_KEY_FOUND'
            binance_api_secret = 'NO_API_SECRET_FOUND'

        if len(config.binance_order_type) > 0 and len(config.binance_timeInForce) > 0:
            binance_order_type = config.binance_order_type
            binance_timeInForce = config.binance_timeInForce
            if binance_order_type == 'MARKET':
                binance_timeInForce = 'Not Applicable'
        else:
            binance_order_type = 'NO_ORDER_TYPE_FOUND'
            binance_timeInForce = 'NO_TIME_IN_FORCE_FOUND'

        return render_template('add_api.html',binance_api_key=binance_api_key,binance_api_secret=binance_api_secret,
                            binance_order_type=binance_order_type,binance_timeInForce=binance_timeInForce)
    except Exception as e:
        print(e)

@app.route('/binance_add_api', methods=['GET', 'POST'])
def binance_add_api():
    output = []
    #importlib.reload(config)
    if request.method == 'POST':
        api_key = request.form.get('api_key')
        api_secret = request.form.get('api_secret')
        if len(api_key) > 0 and len(api_secret) > 0:
            update_config('binance_api_key = ',api_key,'binance_api_secret = ',api_secret)
            output.append('API CREDENTIALS SAVED SUCCESSFULLY')
            try:
                initialise_exchange()
            except Exception as e:
                print(e)
        else:
            output.append('NO API CREDENTIALS SUBMITTED')
    
    write_output(output)
    
    return redirect(url_for('exchange_settings'))

# @app.route('/binance_set_margin', methods=['GET', 'POST'])
# def binance_set_margin():
#     output = []
#     if request.method == 'POST':
#         margin_symbol = request.form.get('margin_symbol').upper()
#         margin_type = request.form.get('margin_type')
#         if len(margin_symbol) > 0 and len(margin_type) > 0:
#             try:
#                 user = get_exchange()
#                 user.fapiPrivatePostMarginType ({'symbol': margin_symbol,'marginType': margin_type,})
#                 output.append(f'Margin Type {margin_type} is Set Successfuly for {margin_symbol}')
#             except:
#                 output.append(f'Margin Type {margin_type} is Already Set for {margin_symbol}')
#     return redirect(url_for('exchange_settings'))

# @app.route('/binance_set_leverage', methods=['GET', 'POST'])
# def binance_set_leverage():
#     if request.method == 'POST':
#         output = []
#         leverage_symbol = request.form.get('leverage_symbol').upper()
#         leverage_value = request.form.get('leverage_value')
#         if len(leverage_symbol) > 0 and len(leverage_value) > 0:
#             try:
#                 user = get_exchange()
#                 user.setLeverage(symbol = leverage_symbol,leverage = int(leverage_value))
#                 output.append(f'Leverage {leverage_value} is Set Successfuly for {leverage_symbol}')
#             except Exception as e:
#                 output.append(e)
#                 output.append(f'Leverage {leverage_value} is NOT Set for {leverage_symbol}')
#
#         write_output(output)
#
#     return redirect(url_for('exchange_settings'))

@app.route('/binance_set_order_type', methods=['GET', 'POST'])
def binance_set_order_type():
    if request.method == 'POST':
        output = []
        order_type = request.form.get('order_type').upper()
        timeinforce = request.form.get('time_in_force').upper()
        if len(order_type) > 0 and len(timeinforce) > 0:
            update_config('binance_order_type = ',order_type,'binance_timeInForce = ',timeinforce)
            output.append('ORDER TYPE SAVED SUCCESSFULLY')
            try:
                initialise_exchange()
            except Exception as e:
                print(e)
        else:
            output.append('NO ORDER TYPE SUBMITTED')

        write_output(output)

    return redirect(url_for('exchange_settings'))



import threading
user = None

def initialise_exchange():
    global user
    importlib.reload(config)
    user = get_exchange()
    threading.Timer(initialise_exchange,70)

try:
    initialise_exchange()
except Exception as e:
    print(e)
    try:
        print('Retrying Exchange... 1')
        initialise_exchange()
    except Exception as e:
        print(e)
        try:
            print('Retrying Exchange... 2')
            initialise_exchange()
        except Exception as e:
                print(e)
                try:
                    print('Retrying Exchange... 3')
                    initialise_exchange()
                except Exception as e:
                        print(e)

@app.route('/webhook', methods=['POST'])
def process():
    try:
        print(request.data)
    except Exception as e:
        print(e)
    data = json.loads(request.data)
    executor = concurrent.futures.ThreadPoolExecutor(max_workers=2*os.cpu_count())

    future = executor.submit(execute_trade, data)
            

    return jsonify({'message': 'Process started'})

# def place_trades(data):
#     try:
#         #time.sleep(0.3)
#         execute_trade(data)
#     except Exception as e:
#         print(e)
#         try:
#             time.sleep(0.5)
#             print('Retrying execute_trade... 1')
#             execute_trade(data)
#         except Exception as e:
#                 print(e)
#                 try:
#                     time.sleep(1)
#                     print('Retrying execute_trade... 2')
#                     execute_trade(data)
#                 except Exception as e:
#                         print(e)


def execute_trade(data):
    try:
        output = []   
        output.append('--------------------------------')
        output.append(f'Process Started')
        output.append('--------------------------------')
        
        symbol, action, price, quantity, market_position = process_syntax(data)
        if symbol.endswith("TUSD"):
            coin_symbol = symbol[:-4] # remove the last 4 characters, which is "TUSD"
            currency = "TUSD"
        
        if symbol.endswith("USDT"):
            coin_symbol = symbol[:-4] # remove the last 4 characters, which is "USDT"
            currency = "USDT"

        if symbol.endswith("USDC"):
            coin_symbol = symbol[:-4] # remove the last 4 characters, which is "USDT"
            currency = "USDC"
        
        try:
            france_tz = pytz.timezone('Europe/Paris')
            current_time = datetime.datetime.now(france_tz)
            formatted_time = current_time.strftime('%Y-%m-%d %H:%M:%S.%f')
            output.append(f'| Date/Time : {formatted_time}')
        except Exception as e:
            output.append(str(e))
        output.append(f'| Symbol : {symbol}')
        output.append(f'| Side : {action}')
        output.append(f'| Price : {price}')
        output.append(f'| Position : {market_position}')
        output.append(f'| Quantity : {quantity}')
        output.append('--------------------------------')
        params = {'type':'spot'}
        username_1 = 'Binance'

        binance_timeInForce = config.binance_timeInForce
        binance_order_type = config.binance_order_type

        # if exchange == 'BINANCE':
        if action == 'buy' and market_position == 'long':
            try: quantity,balance = perc_free_bal(user,params,currency,quantity,price)
            except Exception as e: print(e)
            output.append(f'Buying {quantity} {symbol} | {quantity} % of {balance} {currency} ')
            output.append('------------------------------')
            try:
                time.sleep(0.1)
                if binance_order_type == 'MARKET':
                    future_buy_trade_long(user,symbol,params,username_1,quantity,output)

                if binance_order_type == 'LIMIT':
                    future_buy_trade_long_limit(user,binance_order_type,binance_timeInForce,symbol,quantity,price,output)
            except Exception as e:
                output.append(f'❌ Error Placing Order')
                output.append(f'❌ {e}')
                output.append('------------------------------')

        # if action == 'buy' and market_position == 'flat':
        #     output.append(f'✅ Short Exit Signal Received')
        #     output.append('------------------------------')
        #     try:
        #         future_buy_trade_flat(user,symbol,params,username_1,quantity,output)
        #     except Exception as e:
        #         output.append(f'❌ Error Placing Order')
        #         output.append(f'❌ {e}')
        #         output.append('------------------------------')

        # if action == 'sell' and market_position == 'short':
        #     output.append(f'Selling {quantity} {symbol}')
        #     output.append('------------------------------')
        #     try:
        #         time.sleep(0.1)
        #         if binance_order_type == 'MARKET':
        #             future_sell_trade_short(user,symbol,params,username_1,quantity,output)

        #         if binance_order_type == 'LIMIT':
        #             future_sell_trade_short_limit(user,binance_order_type,binance_timeInForce,symbol,quantity,price,output)
            
        #     except Exception as e:
        #         output.append(f'❌ Error Placing Order')
        #         output.append(f'❌ {e}')
        #         output.append('------------------------------')

        if action == 'sell':# and market_position == 'flat':
            output.append(f'✅ Long Exit Signal Received')
            output.append('------------------------------')
            quantity = fetch_sell_balance(user,coin_symbol,params)
            try:
                future_sell_trade_flat(user,symbol,params,username_1,quantity,output)
            except Exception as e:
                output.append(f'❌ Error Placing Order')
                output.append(f'❌ {e}')
                output.append('------------------------------')

        output.append('#################  End Of Request  ####################')

        write_output(output)

        return "OK"
    except Exception as e:
        write_output(output)
        return "Error"
    

# if __name__ == "__main__":
# 	app.run(host='0.0.0.0',port = 8080, debug=True, threaded = True)